#if !defined(__CONFIG_H__)
#define __CONFIG_H__

// Stuff for the "Start" menu
#define NUM_SHORTCUTS 7

// Number of last run history
#define NUM_LASTRUN_HISTORY 3

// Default config values and config file version information
#define VER_MAJOR 1
#define VER_MINOR 1
#define CONFIG_AUTOSAVE ETrue
#define CONFIG_HOTKEY_ENABLED ETrue
#define CONFIG_NO_DEVICE_PAUSE 60
#define CONFIG_NO_DEVICE_ATTEMPTS 3
#define CONFIG_RESOLVE_HOSTNAME ETrue
#define CONFIG_SHOW_BLUEJACK_SYSMSG ETrue
#define CONFIG_VIBRA_NOTIFY EFalse
#define CONFIG_PROX_SWEEP_ONCE ETrue
#define CONFIG_FLIPFLUSH EFalse
#define CONFIG_FORCE_ENDTASK EFalse
#define CONFIG_SHOW_HIDDEN_TASKS EFalse
#define CONFIG_DECAY_TIME 30
#define CONFIG_OBEX_TIMEOUT 10
#define CONFIG_PERSIST EFalse
#define CONFIG_BEAM_PROTOCOL CBlueBeam::protocolBluetooth		// enum in bjackview.h
#define CONFIG_ZOOM_MAIN ZOOM_INCREMENT * 2
#define CONFIG_ZOOM_FILE ZOOM_INCREMENT
#define CONFIG_ZOOM_BJACK ZOOM_INCREMENT
#define CONFIG_ZOOM_DB ZOOM_INCREMENT * 2
#define CONFIG_ZOOM_SYSINFO ZOOM_INCREMENT
#define CONFIG_FILEMAN_SHOWHIDDEN EFalse
#define CONFIG_AUTO_RUNAPP EFalse
#define CONFIG_AUTO_OPENFILE EFalse
#define CONFIG_FN_ACTIVATED_MENUS 0xFFFF
#define CONFIG_DB_SORT_ASCENDING ETrue
#define CONFIG_ZOOM_AGENDA ZOOM_INCREMENT * 2
// These two mean: by default do you want to see items that have not been completed?
// they don't mean "do you want to see the COMPLETE calendar/todo?" :)
#define CONFIG_AGENDA_SHOW_COMPLETE_CALENDAR EFalse
#define CONFIG_AGENDA_SHOW_COMPLETE_TODO EFalse

#define CONFIG_AGENDA_AUTOEXPAND_CALENDAR ETrue
#define CONFIG_AGENDA_AUTOEXPAND_TODO ETrue
#define CONFIG_FN_DEFAULT_VIEW CSMan2AppUi::EViewTask

/*************************************************************
*
* Config class - holds user configurable options
*
**************************************************************/

class CConfig
{
public:
	TInt iHotkeyDialogResult;
	TUid shortCutUid[NUM_SHORTCUTS];
	TBool autoSave;
	TBool hotkeyEnabled;
	TBool resolveName;
	TBool showBluejackSysMsg;
	TBool proxSweepOnce;
	TBool flipFlush;
	TBool forceEndTask;
	TInt noDevicePause;
	TBool showHiddenTasks;
	TInt noDeviceAttempts;
	TInt decayTime;
	TUint logFlags;
	TInt obexTimeout;
	TBool vibraNotify;
	TFileName audioFileName;
	TBool persist;
	TUint beamProtocol;
	TBool showHiddenFiles;
	TInt zoomMain;
	TInt zoomFile;
	TInt zoomBJack;
	TInt zoomDB;
	TInt zoomSysInfo;
	TBool autoRunApp;
	TBool autoOpenFile;
	TUint fnActivatedMenus;	// Each bit represents each menu item
	TBool dbSortAscending;		// True = sort ascending in list view, False = sort descending
	TInt zoomAgenda;
	TBool agendaShowCompleteCalendar;
	TBool agendaShowCompleteTodo;
	TBool agendaAutoExpandCalendar;
	TBool agendaAutoExpandTodo;
	TInt defaultView;
};

/*************************************************************
*
* Version of config file
*
**************************************************************/

class CVerInfo
{
public:
	TInt majorVersion;
	TInt minorVersion;
};

#endif