#include "dialogs.h"
#include "sman.h"
#include <sman.rsg>

/*************************************************************
*
* Log level dialog
*
**************************************************************/

CLogLevelDialog::~CLogLevelDialog()
{
}

CLogLevelDialog::CLogLevelDialog(TUint *logFlags)
{
	localLogFlags = logFlags;
}

TBool CLogLevelDialog::OkToExitL(TInt aButtonId)
{
	CEikCheckBox *controlLogBluejack = STATIC_CAST(CEikCheckBox*, Control(cLogBluejack));
	CEikCheckBox *controlLogOBEX = STATIC_CAST(CEikCheckBox*, Control(cLogOBEX));
	CEikCheckBox *controlLogScanning = STATIC_CAST(CEikCheckBox*, Control(cLogScanning));
	CEikCheckBox *controlLogDecays = STATIC_CAST(CEikCheckBox*, Control(cLogDecays));
	if (aButtonId == EEikBidOk)
	{
		TUint tempFlags;
		
		tempFlags = 0;
		if (controlLogBluejack->State() == CEikButtonBase::ESet)
			tempFlags = (tempFlags | CLogger::logBluejack);
		if (controlLogOBEX->State() == CEikButtonBase::ESet)
			tempFlags = (tempFlags | CLogger::logOBEX);
		if (controlLogScanning->State() == CEikButtonBase::ESet)
			tempFlags = (tempFlags | CLogger::logScanning);
		if (controlLogDecays->State() == CEikButtonBase::ESet)
			tempFlags = (tempFlags | CLogger::logDecays);
		*localLogFlags = tempFlags;
		return ETrue;
	}
	return ETrue;
} 

void CLogLevelDialog::PreLayoutDynInitL()
{
	CEikCheckBox *controlLogBluejack = STATIC_CAST(CEikCheckBox*, Control(cLogBluejack));
	CEikCheckBox *controlLogOBEX = STATIC_CAST(CEikCheckBox*, Control(cLogOBEX));
	CEikCheckBox *controlLogScanning = STATIC_CAST(CEikCheckBox*, Control(cLogScanning));
	CEikCheckBox *controlLogDecays = STATIC_CAST(CEikCheckBox*, Control(cLogDecays));
	
	if (((*localLogFlags) & CLogger::logBluejack) == CLogger::logBluejack)
		controlLogBluejack->SetState(CEikButtonBase::ESet);
	if (((*localLogFlags) & CLogger::logOBEX) == CLogger::logOBEX)
		controlLogOBEX->SetState(CEikButtonBase::ESet);
	if (((*localLogFlags) & CLogger::logScanning) == CLogger::logScanning)
		controlLogScanning->SetState(CEikButtonBase::ESet);
	if (((*localLogFlags) & CLogger::logDecays) == CLogger::logDecays)
		controlLogDecays->SetState(CEikButtonBase::ESet);
}

/*************************************************************
*
* Bluejack timeout dialogs
*
**************************************************************/

CBluejackTimerDialog::~CBluejackTimerDialog()
{
}

CBluejackTimerDialog::CBluejackTimerDialog(TInt *noDevicePause, TInt *noDeviceAttempts, TInt *decayTime, TInt *obexTimeout)
{
	localNoDevicePause = noDevicePause;
	localNoDeviceAttempts = noDeviceAttempts;
	localDecayTime = decayTime;
	localObexTimeout = obexTimeout;
}

TBool CBluejackTimerDialog::OkToExitL(TInt aButtonId)
{
	CQikNumberEditor *noDevicePause = STATIC_CAST(CQikNumberEditor*, Control(cNoDevicePause));
	CQikNumberEditor *noDeviceAttempts = STATIC_CAST(CQikNumberEditor*, Control(cNoDeviceAttempts));
	CQikNumberEditor *decayTime = STATIC_CAST(CQikNumberEditor*, Control(cDecayTime));
	CQikNumberEditor *obexTimeout = STATIC_CAST(CQikNumberEditor*, Control(cOBEXTimeout));
	if (aButtonId == EEikBidYes)
	{
		noDevicePause->SetValueL(CONFIG_NO_DEVICE_PAUSE);
		noDeviceAttempts->SetValueL(CONFIG_NO_DEVICE_ATTEMPTS);
		decayTime->SetValueL(CONFIG_DECAY_TIME);
		obexTimeout->SetValueL(CONFIG_OBEX_TIMEOUT);
		return EFalse;
	}
	else if (aButtonId == EEikBidOk)
	{
		*localNoDevicePause = noDevicePause->Value();
		*localNoDeviceAttempts = noDeviceAttempts->Value();
		*localDecayTime = decayTime->Value();
		*localObexTimeout = obexTimeout->Value();
		return ETrue;
	}
	return ETrue;
} 

void CBluejackTimerDialog::PreLayoutDynInitL()
{
	CQikNumberEditor *noDevicePause = STATIC_CAST(CQikNumberEditor*, Control(cNoDevicePause));
	noDevicePause->SetValueL(*localNoDevicePause);
	CQikNumberEditor *noDeviceAttempts = STATIC_CAST(CQikNumberEditor*, Control(cNoDeviceAttempts));
	noDeviceAttempts->SetValueL(*localNoDeviceAttempts);
	CQikNumberEditor *decayTime = STATIC_CAST(CQikNumberEditor*, Control(cDecayTime));
	decayTime->SetValueL(*localDecayTime);
	CQikNumberEditor *obexTimeout = STATIC_CAST(CQikNumberEditor*, Control(cOBEXTimeout));
	obexTimeout->SetValueL(*localObexTimeout);
	
	CEikCaptionedControl *decayTimeControl = Line(cDecayTime);
	decayTimeControl->SetDividerAfter(ETrue);
}

/*************************************************************
*
* Hotkey dialog
*
**************************************************************/

CHotkeyDialog::~CHotkeyDialog()
{
}

CHotkeyDialog::CHotkeyDialog(TInt *iHotkey)
{
	localiHotkey = iHotkey;
}

TBool CHotkeyDialog::OkToExitL(TInt aButtonId)
{
	if (aButtonId == EEikBidOk)
	{
		// Save the config changes
		CEikChoiceList *myHotkey = STATIC_CAST(CEikChoiceList*, Control(cHotkeyControl));
		*localiHotkey = myHotkey->CurrentItem();

		return ETrue;
	}
	return EFalse;
} 

void CHotkeyDialog::PreLayoutDynInitL()
{
	CEikChoiceList *hotkeyChoiceList;
	hotkeyChoiceList = STATIC_CAST(CEikChoiceList*, Control(cHotkeyControl));
	hotkeyChoiceList->SetArrayL(R_HOTKEY_ARRAY);	
	hotkeyChoiceList->SetCurrentItem(*localiHotkey);
}

/*************************************************************
*
* Shortcut dialog
*
**************************************************************/

CShortcutDialog::CShortcutDialog(CArrayFixFlat<TUid> *shortCut)
{
	tempUid = shortCut;
	// For each app we get from the app server, store its caption and uid
	appListArray = new (ELeave) CDesCArraySeg(3);
	appListUid = new (ELeave) CArrayFixFlat<TUid>(3);
}

CShortcutDialog::~CShortcutDialog()
{
	delete appListArray;
	delete appListUid;
}

TBool CShortcutDialog::OkToExitL(TInt aButtonId)
{
	if (aButtonId == EEikBidOk)
	{
		if (tempUid != NULL)
		{
			for (int i = 0; i < tempUid->Count(); i++)
			{
				CEikChoiceList *myShortCut = STATIC_CAST(CEikChoiceList*, Control(cShortcut1 + i));
				if (tempUid != NULL)
					tempUid->At(i) = appListUid->At(myShortCut->CurrentItem());
			}
		}
		return ETrue;
	}
	return EFalse;
} 

void CShortcutDialog::PreLayoutDynInitL()
{
	int dump;
	TKeyArrayFix keyArray = TKeyArrayFix(0, ECmpTUint);
	
	populateAppArray();
	if (tempUid != NULL)
	{
		for (int i = 0; i < tempUid->Count(); i++)
		{
			CEikChoiceList *myShortCut = STATIC_CAST(CEikChoiceList*, Control(cShortcut1 + i));
			myShortCut->SetArrayL(appListArray);
			myShortCut->SetArrayExternalOwnership(ETrue);
			if (appListUid->Find(tempUid->At(i), keyArray, dump) == 0)
			{
				myShortCut->SetCurrentItem(dump);
			}
			else
			{
				myShortCut->SetCurrentItem(0);
				tempUid->At(i) = KNullUid;
			}
		}
	}
}

void CShortcutDialog::populateAppArray(void)
{
	// Scan the list of applications registered with the app server
	// For each shortcut uid, set focus to that item

	RApaLsSession mySession;
	TApaAppInfo theAppInfo;
	TApaAppCapabilityBuf aCapabilityBuf;
	TBuf<1> bSeparator;
	TBuf<10> appUid;
	HBufC* aCaption;
	TUid aUid;
	TPtrC currentCaption, temp, temp1;
	TLex lxUid;
	
	mySession.Connect();
	mySession.GetAllApps();
	bSeparator.Append(255);

	// Need to add the length of appUid and bSeparator into this because in the next for-loop, we are
	// appending these to aCaption. By right, we only need 10 + 1 but I'm being paranoid. Besides, what 
	// is an additional 19 bytes anyway? :)
	aCaption = HBufC::NewL(KApaMaxAppCaption + 30);

	// Query the app server
	while (mySession.GetNextApp(theAppInfo) == KErrNone)
	{
		if (mySession.GetAppCapability(aCapabilityBuf, theAppInfo.iUid) == KErrNone)
		{
			// Only scan applications that are not hidden
			if (aCapabilityBuf().iAppIsHidden == EFalse)
			{
				// For each app we get from the app server, store its caption and uid
				aCaption->Des().Copy(theAppInfo.iCaption);
				aCaption->Des().Append(bSeparator);
				appUid.Format(_L("%u"), theAppInfo.iUid);
				aCaption->Des().Append(appUid);
				appListArray->AppendL(*aCaption);
			}
		}
	}
	mySession.Close();
	appListArray->Sort();

	// The first item is for unassigning a shortcut
	if (tempUid != NULL)
	{
		HBufC* dataBuffer = CEikonEnv::Static()->AllocReadResourceL(R_TBUF_UNASSIGNED);
		HBufC* tempCaption = HBufC::NewL(dataBuffer->Length() + 5);
		tempCaption->Des().Format(*dataBuffer, 255, KNullUid);
		delete dataBuffer;
		appListArray->InsertL(0, *tempCaption);
		delete tempCaption;
	}

	// After sorting, separate the UIDs out. I'm doing this because I couldn't find a
	// nicer way of linking the UID to the Caption while sorting.
	// The assumption is there is no app with a 0xff char in its caption...pretty safe i
	// think!!
	for (int i = 0; i < appListArray->Count(); i++)
	{		
		// Get app caption & uid
		currentCaption.Set(appListArray->MdcaPoint(i));
		TextUtils::ColumnText(temp, 0, &currentCaption, TChar(255));
		TextUtils::ColumnText(temp1, 1, &currentCaption, TChar(255));
		aCaption->Des().Copy(temp);
		lxUid.Assign(temp1);
		lxUid.Val(aUid.iUid);
		appListUid->AppendL(aUid);
		appListArray->Delete(i);
		appListArray->InsertL(i, *aCaption);
	}
	
	appListArray->Compress();
	delete aCaption;
}

/*************************************************************
*
* Autostart dialog. This dialog is self-contained. It has code 
* to read and write SMan.boot.
*
**************************************************************/

CAutostartDialog::CAutostartDialog()
{
	appListCaption = new (ELeave) CDesCArrayFlat(3);
	appListPath = new (ELeave) CArrayFixSeg<TFileName>(3);
	appListUid = new (ELeave) CArrayFixFlat<TUid>(3);
	for (int i = 0; i < MAX_AUTOSTART; i++)
	{
		autoStartConfig.autoStartApp[i].Copy(_L(""));
		autoStartConfig.autoStartUid[i] = KNullUid;
		autoStartConfig.autoStartDefaultDoc[i].Copy(_L(""));
	}
}

CAutostartDialog::~CAutostartDialog()
{
	delete appListCaption;
	delete appListPath;
	delete appListUid;
}

void CAutostartDialog::populateAppArray(void)
{
	// Scan the list of applications registered with the app server
	// Store the app's caption and path

	RApaLsSession mySession;
	TApaAppInfo theAppInfo;
	TApaAppCapabilityBuf aCapabilityBuf;
	TBuf<1> bSeparator;
	HBufC* aCaption;
	TPtrC currentCaption, temp, temp1, temp2;
	TBuf<10> appUid;
	TUid aUid;
	TLex lxUid;
	
	mySession.Connect();
	mySession.GetAllApps();
	bSeparator.Append(255);

	aCaption = HBufC::NewL(KApaMaxAppCaption + 30 + KMaxFileName);

	// Query the app server
	while (mySession.GetNextApp(theAppInfo) == KErrNone)
	{
		if (mySession.GetAppCapability(aCapabilityBuf, theAppInfo.iUid) == KErrNone)
		{
			// Only scan applications that are not hidden
			if (aCapabilityBuf().iAppIsHidden == EFalse)
			{
				// For each app we get from the app server, store its caption and path
				aCaption->Des().Copy(theAppInfo.iCaption);
				aCaption->Des().Append(bSeparator);
				aCaption->Des().Append(theAppInfo.iFullName);
				aCaption->Des().Append(bSeparator);
				appUid.Format(_L("%u"), theAppInfo.iUid);
				aCaption->Des().Append(appUid);
				appListCaption->AppendL(*aCaption);
			}
		}
	}
	mySession.Close();
	appListCaption->Sort();

	// The first item is for unassigning an autostart
	HBufC* dataBuffer = CEikonEnv::Static()->AllocReadResourceL(R_TBUF_UNASSIGNED2);
	HBufC* tempCaption = HBufC::NewL(dataBuffer->Length() + 10);
	tempCaption->Des().Format(*dataBuffer, 255, 0, 255, KNullUid);
	delete dataBuffer;
	appListCaption->InsertL(0, *tempCaption);
	delete tempCaption;

/*
	aCaption = aCaption->ReAllocL(KApaMaxAppCaption + dataBuffer->Length() + 5);
	aCaption->Des().Format(*dataBuffer, 255, 0, 255, KNullUid);
	delete dataBuffer;
	//aCaption.Format(_L("<unassigned>%c%c%c%c"), 255, 0, 255, KNullUid);
	appListCaption->InsertL(0, *aCaption);
*/

	for (int i = 0; i < appListCaption->Count(); i++)
	{		
		// Get app caption, path and uid
		currentCaption.Set(appListCaption->MdcaPoint(i));
		TextUtils::ColumnText(temp, 0, &currentCaption, TChar(255));
		TextUtils::ColumnText(temp1, 1, &currentCaption, TChar(255));
		TextUtils::ColumnText(temp2, 2, &currentCaption, TChar(255));
		appListPath->AppendL(temp1);
		aCaption->Des().Copy(temp);
		lxUid.Assign(temp2);
		lxUid.Val(aUid.iUid);
		appListUid->AppendL(aUid);		
		appListCaption->Delete(i);
		appListCaption->InsertL(i, *aCaption);
	}
	delete aCaption;
	appListCaption->Compress();
}

void CAutostartDialog::PreLayoutDynInitL()
{
	loadBootFile();
	populateAppArray();

	int dump;
	TKeyArrayFix keyArray = TKeyArrayFix(0, ECmpNormal);
	
	for (int i = 0; i < MAX_AUTOSTART - 1; i++)
	{
		CEikChoiceList *myChoice1 = STATIC_CAST(CEikChoiceList*, Control(cAutoStart1 + i));
		myChoice1->SetArrayL(appListCaption);
		myChoice1->SetArrayExternalOwnership(ETrue);
		if (appListPath->Find(autoStartConfig.autoStartApp[i], keyArray, dump) == 0)
		{
			myChoice1->SetCurrentItem(dump);
		}
		else
		{
			myChoice1->SetCurrentItem(0);
		}
	}
}

TBool CAutostartDialog::OkToExitL(TInt aButtonId)
{
	if (aButtonId == EEikBidOk)
	{
		for (int i = 0; i < MAX_AUTOSTART - 1; i++)
		{
			CEikChoiceList *myChoice1 = STATIC_CAST(CEikChoiceList*, Control(cAutoStart1 + i));
			if (myChoice1->CurrentItem() > 0)
			{
				autoStartConfig.autoStartApp[i].Copy(appListPath->At(myChoice1->CurrentItem()));
				autoStartConfig.autoStartUid[i] = appListUid->At(myChoice1->CurrentItem());
				TRAPD(err, QikFileUtils::MakeAppDocumentFileNameL(autoStartConfig.autoStartDefaultDoc[i], autoStartConfig.autoStartUid[i]));
				if (err != KErrNone)
					autoStartConfig.autoStartDefaultDoc[i].Copy(_L(""));
			}
			else
			{
				autoStartConfig.autoStartApp[i].Copy(_L(""));
				autoStartConfig.autoStartUid[i] = KNullUid;
				autoStartConfig.autoStartDefaultDoc[i].Copy(_L(""));
			}
		}
		if (saveBootFile() != 0)
			iEikonEnv->InfoMsgWithAlignment(TGulAlignment(EHRightVCenter), R_TBUF_ERRSAVECONFIG);
	}
	return ETrue;
}

TUint CAutostartDialog::loadBootFile(void)
{
	RFile inStream;
	TInt retVal;
	
	retVal = 1;
	if (inStream.Open(iEikonEnv->Static()->FsSession(), _L("C:\\SMan.boot"), EFileRead) == KErrNone)
	{
		TPckg<CAutoStartConfig> pkgConfigData(autoStartConfig);
		if (inStream.Read(pkgConfigData) == KErrNone)
			retVal = 0;
		inStream.Close();
	}
	return retVal;
}

TUint CAutostartDialog::saveBootFile(void)
{
	RFile outStream;
	TInt retVal;
	
	retVal = 1;
	if (outStream.Replace(iEikonEnv->Static()->FsSession(), _L("C:\\SMan.boot"), EFileRead) == KErrNone)
	{
		TPckg<CAutoStartConfig> pkgConfigData(autoStartConfig);
		if (outStream.Write(pkgConfigData) == KErrNone)
			retVal = 0;
		outStream.Close();
	}
	return retVal;
}

/*************************************************************
*
* Bluebeam log dialog.
*
**************************************************************/

CBluebeamLogDialog::CBluebeamLogDialog(CLogger *logObj)
{
	localLogObj = logObj;
}

void CBluebeamLogDialog::PostLayoutDynInitL()
{
	localLogObj->logDialog = this;
}

CBluebeamLogDialog::~CBluebeamLogDialog()
{
	localLogObj->logDialog = NULL;
}

void CBluebeamLogDialog::PreLayoutDynInitL()
{
	CEikGlobalTextEditor* textEditor = STATIC_CAST(CEikGlobalTextEditor*,Control(cBluebeamLog));
	
	textEditor->CreateScrollBarFrameL();
	textEditor->ScrollBarFrame()->SetScrollBarVisibilityL(CEikScrollBarFrame::EAuto, CEikScrollBarFrame::EAuto);
    
	ButtonGroupContainer().DimCommand(EEikBidYes, ETrue);
}

TBool CBluebeamLogDialog::OkToExitL(TInt aButtonId)
{
	if (aButtonId != EEikBidYes)
		static_cast<CSMan2AppUi*>(CEikonEnv::Static()->EikAppUi())->iFileView->blueBeam->Cancel();
	return ETrue;
}

/*************************************************************
*
* Bluejack notifications dialog.
*
**************************************************************/
CBluejackNotifications::CBluejackNotifications(CConfig *cData)
{
	configData = cData;
}

CBluejackNotifications::~CBluejackNotifications()
{
}

void CBluejackNotifications::PreLayoutDynInitL()
{
	CEikCheckBox *controlVibraNotify = STATIC_CAST(CEikCheckBox*, Control(cVibraNotify));
	CEikCheckBox *controlSystemMsgNotify = STATIC_CAST(CEikCheckBox*, Control(cSystemMsgNotify));
	if (configData->showBluejackSysMsg == true)
		controlSystemMsgNotify->SetState(CEikButtonBase::ESet);
	if (configData->vibraNotify == true)
		controlVibraNotify->SetState(CEikButtonBase::ESet);
	CEikChoiceList *audioClip = STATIC_CAST(CEikChoiceList*, Control(cAudioFileName));
	audioClip->SetArrayL(R_ARRAY_AUDIONOTIFY);
	if (configData->audioFileName.Length() == 0)
		audioClip->SetCurrentItem(0);
	else
	{
		selectedAudioFileName.Copy(configData->audioFileName);
		TParsePtr parsedAudioFileName(configData->audioFileName);
		audioClip->DesCArray()->AppendL(parsedAudioFileName.NameAndExt());
		audioClip->SetCurrentItem(2);
	}
}

TBool CBluejackNotifications::OkToExitL(TInt aButtonId)
{
	if (aButtonId == EEikBidOk)
	{
		CEikCheckBox *controlVibraNotify = STATIC_CAST(CEikCheckBox*, Control(cVibraNotify));
		CEikCheckBox *controlSystemMsgNotify = STATIC_CAST(CEikCheckBox*, Control(cSystemMsgNotify));		
		if (controlVibraNotify->State() == CEikButtonBase::ESet)
			configData->vibraNotify = ETrue;
		else
			configData->vibraNotify = EFalse;
		if (controlSystemMsgNotify->State() == CEikButtonBase::ESet)
			configData->showBluejackSysMsg = ETrue;
		else
			configData->showBluejackSysMsg = EFalse;
		CEikChoiceList *audioClip = STATIC_CAST(CEikChoiceList*, Control(cAudioFileName));
		if (audioClip->CurrentItem() == 0)
			configData->audioFileName.Copy(_L(""));
		else
			configData->audioFileName.Copy(selectedAudioFileName);
	}
	return ETrue;
}

void CBluejackNotifications::HandleControlStateChangeL(TInt aControlId)
{
	if (aControlId == cAudioFileName)
	{
		CEikChoiceList *audioClip = STATIC_CAST(CEikChoiceList*, Control(cAudioFileName));
		if (audioClip->CurrentItem() == 1)
		{
			pickAudioFile();
		}
	}
}

void CBluejackNotifications::pickAudioFile()
{
	CDesCArray* audioMimeArray = new(ELeave) CDesCArrayFlat(2);
	CEikChoiceList *audioClip = STATIC_CAST(CEikChoiceList*, Control(cAudioFileName));
	audioMimeArray->AppendL(_L("audio/x-wav"));		// WAV
	audioMimeArray->AppendL(_L("audio/x-midi"));		// MID
	audioMimeArray->AppendL(_L("audio/x-rmf"));		// RMF
	if (CQikSelectMediaFileDlg::RunDlgLD(*audioMimeArray, selectedAudioFileName))
	{
		if (audioClip->DesCArray()->MdcaCount() > 2)
			audioClip->DesCArray()->Delete(2);
		TParsePtr parsedAudioFileName(selectedAudioFileName);
		configData->audioFileName.Copy(selectedAudioFileName);
		audioClip->DesCArray()->AppendL(parsedAudioFileName.NameAndExt());
		audioClip->SetCurrentItem(2);
	}
	else
	{
		audioClip->SetCurrentItem(0);
	}
	audioClip->DesCArray()->Compress();
	delete audioMimeArray;
}

/*************************************************************
*
* Edit the bluejack vcard
*
**************************************************************/
CBluejackMessageDialog::CBluejackMessageDialog(CScanner *scannerObj)
{
	localScannerObj = scannerObj;
}

CBluejackMessageDialog::~CBluejackMessageDialog()
{
}

void CBluejackMessageDialog::makeVCard(void)
{
	RFile outStream;
	TBuf8<MAX_VCARD_SIZE> vcardBuffer8bit;
	
	vcardBuffer8bit.Copy(currBJackMsg);
	vcardBuffer8bit.Insert(0, _L8("BEGIN:VCARD\r\nVERSION:2.1\r\nN:"));
	vcardBuffer8bit.Append(_L8("\r\nEND:VCARD"));
	if (outStream.Replace(iEikonEnv->Static()->FsSession(), localScannerObj->vCardNames[0], EFileRead) == KErrNone)
	{
		outStream.Write(vcardBuffer8bit);
		outStream.Close();
	}
}

TBool CBluejackMessageDialog::OkToExitL(TInt aButtonId)
{
	if (aButtonId == EEikBidOk)
	{
		CEikGlobalTextEditor* textEditor = STATIC_CAST(CEikGlobalTextEditor*,Control(cBluejackMessage));
		textEditor->GetText(currBJackMsg);
		makeVCard();
	}
	return ETrue;
}

void CBluejackMessageDialog::PreLayoutDynInitL()
{
	// Read the existing vcard
	
	RFile inStream;
	TBuf8<MAX_VCARD_SIZE> buffer8bit;

	buffer8bit.Copy(_L(""));
	if (inStream.Open(iEikonEnv->Static()->FsSession(), localScannerObj->vCardNames[0], EFileRead) == KErrNone)
	{
		TInt fileSize;
		
		inStream.Size(fileSize);
		if ((fileSize > 1) && (fileSize < MAX_VCARD_SIZE))
			inStream.Read(buffer8bit);
		inStream.Close();
	}
	currBJackMsg.Copy(buffer8bit);
	TInt nameField = currBJackMsg.Find(_L("\r\nN:"));
	if (nameField != KErrNotFound)
	{
		currBJackMsg = currBJackMsg.Mid(nameField + 4, currBJackMsg.Length() - nameField - 4);
		nameField = currBJackMsg.Find(_L("\r\n"));
		if (nameField != KErrNotFound)
			currBJackMsg.SetLength(nameField);
	}
	if (currBJackMsg.Length() > MAX_VCARD_FULLNAME)
		currBJackMsg.SetLength(MAX_VCARD_FULLNAME);
	CEikGlobalTextEditor* textEditor = STATIC_CAST(CEikGlobalTextEditor*,Control(cBluejackMessage));
	textEditor->SetTextL(&currBJackMsg);
}

/*************************************************************
*
* Fileman log dialog - with wait
*
**************************************************************/
void CFileManLogDialog::PostLayoutDynInitL()
{
	CEikGlobalTextEditor* textEditor = STATIC_CAST(CEikGlobalTextEditor*,Control(cFileManProgressText));
	
	textEditor->CreateScrollBarFrameL();
	textEditor->ScrollBarFrame()->SetScrollBarVisibilityL(CEikScrollBarFrame::EAuto, CEikScrollBarFrame::EAuto);
	textEditor->SetTextL(&text);
	if (!showOverwrite)
	{
		ButtonGroupContainer().DimCommand(EEikBidOverwrite, ETrue);
		ButtonGroupContainer().DimCommand(EEikBidOverwriteAll, ETrue);
	}
}

/*************************************************************
*
* Fileman rename dialog
*
**************************************************************/
void CFileManRenDialog::PreLayoutDynInitL()
{
	static_cast<CEikGlobalTextEditor*>(Control(cFileManNewName))->SetTextL(&fileName);
	fileName.Insert(0, filePath);
}

TBool CFileManRenDialog::OkToExitL(TInt aButtonId)
{
	TBool retVal;
		
	retVal = EFalse;
	if ((aButtonId == EEikBidAbort) || (aButtonId == EEikBidSkip))
		retVal = ETrue;
	else if (aButtonId == EEikBidOk)
	{
		static_cast<CEikGlobalTextEditor*>(Control(cFileManNewName))->GetText(newName);

		TParsePtr sanityCheck(newName);
		if (!sanityCheck.PathPresent())
		{
			newName.Insert(0, filePath);
			if (EikFileUtils::RenameFile(fileName, newName, 0) == KErrNone)
				retVal = ETrue;
			else
				CEikonEnv::Static()->InfoMsg(R_TBUF_FILEMAN_ERRRENAME);
		}
		else
			CEikonEnv::Static()->InfoMsg(R_TBUF_FILEMAN_INVALIDFILENAME);
	}
	return retVal;
}

/*************************************************************
*
* Fileman new folder dialog
*
**************************************************************/
TBool CFileManNewDirDialog::OkToExitL(TInt aButtonId)
{
	TBool retVal;
	retVal = EFalse;

	if (aButtonId == EEikBidOk)
	{
		TFileName newName;
		RFs fileServer;
		
		static_cast<CEikGlobalTextEditor*>(Control(cFileManNewName))->GetText(newName);
		User::LeaveIfError(fileServer.Connect());
		newName.Insert(0, currentPath);
		newName.Append(_L("\\"));
		if (fileServer.MkDirAll(newName) == KErrNone)
			retVal = ETrue;
		else
			CEikonEnv::Static()->InfoMsg(R_TBUF_FILEMAN_ERRMKDIR);
		fileServer.Close();
	}
	return retVal;
}

/*************************************************************
*
* Fileman attributes dialog
*
**************************************************************/
CFileManAttrDialog::CFileManAttrDialog()
{
	User::LeaveIfError(fs.Connect());	
}

CFileManAttrDialog::~CFileManAttrDialog()
{
	fs.Close();
}

TKeyResponse CFileManAttrDialog::OfferKeyEventL(const TKeyEvent& aKeyEvent,TEventCode aType)
{
	if (aType == EEventKey)
	{
		if (aKeyEvent.iCode == EQuartzKeyTwoWayDown)
		{
			static_cast<CEikGlobalTextEditor*>(Control(cFileAttName))->MoveDisplayL(TCursorPosition::EFPageDown);
			static_cast<CEikGlobalTextEditor*>(Control(cFileAttName))->UpdateScrollBarsL();
			return EKeyWasConsumed;
		}
		else if (aKeyEvent.iCode == EQuartzKeyTwoWayUp)
		{
			static_cast<CEikGlobalTextEditor*>(Control(cFileAttName))->MoveDisplayL(TCursorPosition::EFPageUp);
			static_cast<CEikGlobalTextEditor*>(Control(cFileAttName))->UpdateScrollBarsL();
			return EKeyWasConsumed;
		}
	}
	return CEikDialog::OfferKeyEventL(aKeyEvent, aType);
}

void CFileManAttrDialog::PostLayoutDynInitL()
{
	TEntry fileAtt;
	CEikGlobalTextEditor *textEditor = STATIC_CAST(CEikGlobalTextEditor*, Control(cFileAttName));
	textEditor->CreateScrollBarFrameL();
	textEditor->ScrollBarFrame()->SetScrollBarVisibilityL(CEikScrollBarFrame::EAuto, CEikScrollBarFrame::EAuto);

	if (fs.Entry(theFile, fileAtt) == KErrNone)
	{
		TParsePtr parsedFile(theFile);
		textEditor->SetTextL(&(parsedFile.FullName()));
		
		HBufC* dataBufferSize;
		TBuf<2> lineBreak;
		lineBreak.Append(CEditableText::ELineBreak);
		lineBreak.Append(CEditableText::ELineBreak);
		if (!fileAtt.IsDir())
		{
			dataBufferSize = CEikonEnv::Static()->AllocReadResourceL(R_TBUF_FILEMAN_PROP_SIZE);
			
			TInt comma = 0;
			TBuf<20> textNumeric;
			textNumeric.Format(_L("%d"), fileAtt.iSize);
			if (fileAtt.iSize > 999)
			{
				textNumeric.Insert(textNumeric.Length() - 3, _L(","));
				comma++;
			}
			if (fileAtt.iSize > 999999)
				textNumeric.Insert(textNumeric.Length() - 3 - comma - 3, _L(","));
			
			dataBufferSize = dataBufferSize->ReAllocL(dataBufferSize->Length() + textNumeric.Length());
			dataBufferSize->Des().Append(textNumeric);
	
			HBufC* dataBufferByte = CEikonEnv::Static()->AllocReadResourceL(R_TBUF_FILEMAN_PROP_BYTE);
			dataBufferSize = dataBufferSize->ReAllocL(dataBufferSize->Length() + dataBufferByte->Length());
			dataBufferSize->Des().Append(*dataBufferByte);
			delete dataBufferByte;
		}
		else
			dataBufferSize = CEikonEnv::Static()->AllocReadResourceL(R_TBUF_FILEMAN_PROP_ISFOLDER);
					
		TBuf<50> tempTime;
		fileAtt.iModified.FormatL(tempTime, _L("%/0%1%/1%2%/2%3%/3 %-B%:0%J%:1%T%:2%S%:3%+B  "));
		HBufC* dataBufferLastMod = CEikonEnv::Static()->AllocReadResourceL(R_TBUF_FILEMAN_PROP_LASTMOD);
		dataBufferSize = dataBufferSize->ReAllocL(dataBufferSize->Length() + tempTime.Length() + lineBreak.Length() + dataBufferLastMod->Length());
		dataBufferSize->Des().Append(lineBreak);
		dataBufferSize->Des().Append(*dataBufferLastMod);
		delete dataBufferLastMod;
		dataBufferSize->Des().Append(tempTime);
		
		textEditor->InsertDeleteCharsL(textEditor->TextLength(), lineBreak, TCursorSelection(0, 0));
		textEditor->InsertDeleteCharsL(textEditor->TextLength(), *dataBufferSize, TCursorSelection(0, 0));
		
		delete dataBufferSize;
		
		if (fileAtt.IsReadOnly())
			static_cast<CEikCheckBox*>(Control(cFileAttReadOnly))->SetState(CEikButtonBase::ESet);
		if (fileAtt.IsArchive())
			static_cast<CEikCheckBox*>(Control(cFileAttArchive))->SetState(CEikButtonBase::ESet);
		if (fileAtt.IsHidden())
			static_cast<CEikCheckBox*>(Control(cFileAttHidden))->SetState(CEikButtonBase::ESet);
		if (fileAtt.IsSystem())
			static_cast<CEikCheckBox*>(Control(cFileAttSystem))->SetState(CEikButtonBase::ESet);
	}
	else
	{
		HBufC* dataBuffer = CEikonEnv::Static()->AllocReadResourceL(R_TBUF_FILEMAN_ERRREADATTR);
		textEditor->SetTextL(dataBuffer);
		delete dataBuffer;
	}
}

TBool CFileManAttrDialog::OkToExitL(TInt aButtonId)
{
	TInt attSetFlags = 0;
	TInt attClearFlags = 0;
	
	if (static_cast<CEikCheckBox*>(Control(cFileAttReadOnly))->State() == CEikButtonBase::ESet)
		attSetFlags = attSetFlags | KEntryAttReadOnly;
	else
		attClearFlags = attClearFlags | KEntryAttReadOnly;

	if (static_cast<CEikCheckBox*>(Control(cFileAttHidden))->State() == CEikButtonBase::ESet)
		attSetFlags = attSetFlags | KEntryAttHidden;
	else
		attClearFlags = attClearFlags | KEntryAttHidden;

	if (static_cast<CEikCheckBox*>(Control(cFileAttSystem))->State() == CEikButtonBase::ESet)
		attSetFlags = attSetFlags | KEntryAttSystem;
	else
		attClearFlags = attClearFlags | KEntryAttSystem;

	if (static_cast<CEikCheckBox*>(Control(cFileAttArchive))->State() == CEikButtonBase::ESet)
		attSetFlags = attSetFlags | KEntryAttArchive;
	else
		attClearFlags = attClearFlags | KEntryAttArchive;
	
	if (aButtonId == EEikBidOk)
	{
		if (fs.SetAtt(theFile, attSetFlags, attClearFlags) != KErrNone)
			iEikonEnv->InfoMsg(R_TBUF_FILEMAN_ERRSETATTRIBS);
	}
	return ETrue;
}

/*************************************************************
*
* Fn Menu toggling
*
**************************************************************/

CFnMenuToggle::CFnMenuToggle(TUint *bits, TInt *defaultView)
{
	toggleBits = bits;
	theDefaultView = defaultView;
}

CFnMenuToggle::~CFnMenuToggle()
{
}

TBool CFnMenuToggle::OkToExitL(TInt aButtonId)
{
	TUint tempBits = 0;
	
	if (aButtonId == EEikBidOk)
	{
		if (((CEikCheckBox*)(Control(cFnToggleMenu1)))->State() == CEikButtonBase::ESet)
			tempBits = tempBits | 1;
		if (((CEikCheckBox*)(Control(cFnToggleMenu2)))->State() == CEikButtonBase::ESet)
			tempBits = tempBits | 2;
		if (((CEikCheckBox*)(Control(cFnToggleMenu3)))->State() == CEikButtonBase::ESet)
			tempBits = tempBits | 4;
		if (((CEikCheckBox*)(Control(cFnToggleMenu4)))->State() == CEikButtonBase::ESet)
			tempBits = tempBits | 8;
		if (((CEikCheckBox*)(Control(cFnToggleMenu5)))->State() == CEikButtonBase::ESet)
			tempBits = tempBits | 16;
		*toggleBits = tempBits;
		
		*theDefaultView = static_cast<CEikChoiceList*>(Control(cFnStartupView))->CurrentItem();
	}
	return ETrue;
}

void CFnMenuToggle::PreLayoutDynInitL()
{
	if ((*toggleBits & 1) > 0)
		((CEikCheckBox*)(Control(cFnToggleMenu1)))->SetState(CEikButtonBase::ESet);
	if ((*toggleBits & 2) > 0)
		((CEikCheckBox*)(Control(cFnToggleMenu2)))->SetState(CEikButtonBase::ESet);
	if ((*toggleBits & 4) > 0)
		((CEikCheckBox*)(Control(cFnToggleMenu3)))->SetState(CEikButtonBase::ESet);
	if ((*toggleBits & 8) > 0)
		((CEikCheckBox*)(Control(cFnToggleMenu4)))->SetState(CEikButtonBase::ESet);
	if ((*toggleBits & 16) > 0)
		((CEikCheckBox*)(Control(cFnToggleMenu5)))->SetState(CEikButtonBase::ESet);

	CEikCaptionedControl *separatorControl = Line(cFnToggleMenu5);
	separatorControl->SetDividerAfter(ETrue);
		
	CEikChoiceList *defaultViewChoice = STATIC_CAST(CEikChoiceList*, Control(cFnStartupView));
	defaultViewChoice->SetCurrentItem(*theDefaultView);
}

/*************************************************************
*
* CRC progress dialog
*
**************************************************************/

CCRCDialog::CCRCDialog(TPtrC fileName)
{
	theFileName.Set(fileName);
	static_cast<CSMan2AppUi*>(CEikonEnv::Static()->EikAppUi())->iFileView->crcCalculator->crcDialogActive = ETrue;
}

void CCRCDialog::stopCRC()
{
	static_cast<CSMan2AppUi*>(CEikonEnv::Static()->EikAppUi())->iFileView->crcCalculator->crcDialogActive = EFalse;
	static_cast<CSMan2AppUi*>(CEikonEnv::Static()->EikAppUi())->iFileView->crcCalculator->Cancel();
}

CCRCDialog::~CCRCDialog()
{
	stopCRC();
}

void CCRCDialog::PreLayoutDynInitL()
{
	static_cast<CEikProgressInfo*>(Control(cCRCProgress))->SetFinalValue(100);
	static_cast<CEikProgressInfo*>(Control(cCRCProgress))->SetAndDraw(0);
	static_cast<CEikLabel*>(Control(cCRCValue))->SetTextL(_L("Calculating....."));
	TFileName tempCopy;
	tempCopy.Copy(theFileName);
	TParsePtr theParsedFile(tempCopy);
	static_cast<CEikLabel*>(Control(cCRCFileName))->SetTextL(theParsedFile.NameAndExt());
	ButtonGroupContainer().DimCommand(EEikBidOk, ETrue);
}

void CCRCDialog::updateProgress(TInt aProgress)
{
	static_cast<CEikProgressInfo*>(Control(cCRCProgress))->SetAndDraw(aProgress);
}

/*************************************************************
*
* DB progress dialog
*
**************************************************************/

CDBProgressDialog::CDBProgressDialog()
{
}

CDBProgressDialog::~CDBProgressDialog()
{
}

void CDBProgressDialog::PostLayoutDynInitL()
{
	static_cast<CEikProgressInfo*>(Control(cDBCompactProgress))->SetFinalValue(0);
	static_cast<CEikProgressInfo*>(Control(cDBCompactProgress))->SetAndDraw(0);
}

void CDBProgressDialog::updateProgress(TInt aProgress)
{
	static_cast<CEikProgressInfo*>(Control(cDBCompactProgress))->SetAndDraw(aProgress);
}

void CDBProgressDialog::setProgressMaxValue(TInt aMaxValue)
{
	static_cast<CEikProgressInfo*>(Control(cDBCompactProgress))->SetFinalValue(aMaxValue);
}

/*************************************************************
*
* Generic dialog to get password
*
**************************************************************/

CGetPasswordDialog::CGetPasswordDialog(TPassword *thePassword)
{
	localPassword = thePassword;
}

CGetPasswordDialog::~CGetPasswordDialog()
{
}

TBool CGetPasswordDialog::OkToExitL(TInt aButtonId)
{
	if (aButtonId == EEikBidOk)
		static_cast<CEikSecretEditor*>(Control(cDBPassword))->GetText(*localPassword);
	return ETrue;
}

/*************************************************************
*
* Generic dialog to change password
*
**************************************************************/

CSetPasswordDialog::CSetPasswordDialog(TPassword *thePassword)
{
	localPassword = thePassword;
}

CSetPasswordDialog::~CSetPasswordDialog()
{
}

TBool CSetPasswordDialog::OkToExitL(TInt aButtonId)
{
	if (aButtonId == EEikBidOk)
	{
		TPassword password1, password2;
		static_cast<CEikSecretEditor*>(Control(cDBPassword))->GetText(password1);
		static_cast<CEikSecretEditor*>(Control(cDBPasswordReEnter))->GetText(password2);
		
		if (password1.Compare(password2) == 0)
			static_cast<CEikSecretEditor*>(Control(cDBPassword))->GetText(*localPassword);
		else
		{
			iEikonEnv->InfoMsg(R_TBUF_DB_ERR_PASSWORDNOMATCH);
			return EFalse;
		}
	}
	return ETrue;
}

/*************************************************************
*
* Detailed calendar dialog
*
**************************************************************/
TKeyResponse CAgendaDetail::OfferKeyEventL(const TKeyEvent& aKeyEvent,TEventCode aType)
{
	if (aType == EEventKey)
	{
		if (aKeyEvent.iCode == EQuartzKeyTwoWayDown)
		{
			static_cast<CEikGlobalTextEditor*>(Control(cAgendaDetailNotes))->MoveDisplayL(TCursorPosition::EFPageDown);
			static_cast<CEikGlobalTextEditor*>(Control(cAgendaDetailNotes))->UpdateScrollBarsL();
			return EKeyWasConsumed;
		}
		else if (aKeyEvent.iCode == EQuartzKeyTwoWayUp)
		{
			static_cast<CEikGlobalTextEditor*>(Control(cAgendaDetailNotes))->MoveDisplayL(TCursorPosition::EFPageUp);
			static_cast<CEikGlobalTextEditor*>(Control(cAgendaDetailNotes))->UpdateScrollBarsL();
			return EKeyWasConsumed;
		}
	}
	return CEikDialog::OfferKeyEventL(aKeyEvent, aType);
}

CAgendaDetail::CAgendaDetail()
{
}

CAgendaDetail::~CAgendaDetail()
{
}

void CAgendaDetail::PostLayoutDynInitL()
{
	static_cast<CEikGlobalTextEditor*>(Control(cAgendaDetailNotes))->CreateScrollBarFrameL();
	static_cast<CEikGlobalTextEditor*>(Control(cAgendaDetailNotes))->ScrollBarFrame()->SetScrollBarVisibilityL(CEikScrollBarFrame::EAuto, CEikScrollBarFrame::EAuto);
	static_cast<CEikGlobalTextEditor*>(Control(cAgendaDetailNotes))->SetCursorPosL(0, EFalse);	
}

void CAgendaDetail::PreLayoutDynInitL()
{
	static_cast<CEikLabel*>(Control(cAgendaDetailStartDateTime))->SetTextL(*startDateTime);
	static_cast<CEikLabel*>(Control(cAgendaDetailEndDateTime))->SetTextL(*endDateTime);
	static_cast<CEikLabel*>(Control(cAgendaDetailAlarmDateTime))->SetTextL(*alarmDateTime);
	static_cast<CEikLabel*>(Control(cAgendaDetailLocation))->SetTextL(*location);

	static_cast<CEikGlobalTextEditor*>(Control(cAgendaDetailNotes))->SetTextL(&notes);
}

/*************************************************************
*
* Detailed todo dialog
*
**************************************************************/
TKeyResponse CTodoDetail::OfferKeyEventL(const TKeyEvent& aKeyEvent,TEventCode aType)
{
	if (aType == EEventKey)
	{
		if (aKeyEvent.iCode == EQuartzKeyTwoWayDown)
		{
			static_cast<CEikGlobalTextEditor*>(Control(cAgendaDetailNotes))->MoveDisplayL(TCursorPosition::EFPageDown);
			static_cast<CEikGlobalTextEditor*>(Control(cAgendaDetailNotes))->UpdateScrollBarsL();
			return EKeyWasConsumed;
		}
		else if (aKeyEvent.iCode == EQuartzKeyTwoWayUp)
		{
			static_cast<CEikGlobalTextEditor*>(Control(cAgendaDetailNotes))->MoveDisplayL(TCursorPosition::EFPageUp);
			static_cast<CEikGlobalTextEditor*>(Control(cAgendaDetailNotes))->UpdateScrollBarsL();
			return EKeyWasConsumed;
		}
	}
	return CEikDialog::OfferKeyEventL(aKeyEvent, aType);
}

CTodoDetail::CTodoDetail()
{
}

CTodoDetail::~CTodoDetail()
{
}

void CTodoDetail::PostLayoutDynInitL()
{
	static_cast<CEikGlobalTextEditor*>(Control(cAgendaDetailNotes))->CreateScrollBarFrameL();
	static_cast<CEikGlobalTextEditor*>(Control(cAgendaDetailNotes))->ScrollBarFrame()->SetScrollBarVisibilityL(CEikScrollBarFrame::EAuto, CEikScrollBarFrame::EAuto);
	static_cast<CEikGlobalTextEditor*>(Control(cAgendaDetailNotes))->SetCursorPosL(0, EFalse);	
}

void CTodoDetail::PreLayoutDynInitL()
{
	static_cast<CEikLabel*>(Control(cAgendaDetailEndDateTime))->SetTextL(*dueDateTime);
	static_cast<CEikLabel*>(Control(cAgendaDetailAlarmDateTime))->SetTextL(*alarmDateTime);
	static_cast<CEikLabel*>(Control(cAgendaDetailPriority))->SetTextL(*priority);

	static_cast<CEikGlobalTextEditor*>(Control(cAgendaDetailNotes))->SetTextL(&notes);
}
